Index: palm/trunk/SOURCE/data_output_3d.f90
===================================================================
--- palm/trunk/SOURCE/data_output_3d.f90	(revision 4901)
+++ palm/trunk/SOURCE/data_output_3d.f90	(revision 1)
@@ -1,82 +1,59 @@
-!> @file data_output_3d.f90
-!--------------------------------------------------------------------------------------------------!
-! This file is part of the PALM model system.
-!
-! PALM is free software: you can redistribute it and/or modify it under the terms of the GNU General
-! Public License as published by the Free Software Foundation, either version 3 of the License, or
-! (at your option) any later version.
-!
-! PALM is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
-! implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
-! Public License for more details.
-!
-! You should have received a copy of the GNU General Public License along with PALM. If not, see
-! <http://www.gnu.org/licenses/>.
-!
-! Copyright 1997-2021 Leibniz Universitaet Hannover
-!--------------------------------------------------------------------------------------------------!
-!
-! Current revisions:
-! ------------------
-!
+ SUBROUTINE data_output_3d( av )
+
+!------------------------------------------------------------------------------!
+! Actual revisions:
+! -----------------
+! 
 !
 ! Former revisions:
 ! -----------------
-! $Id$
-! Keep 32-bit output for netcdf_data_output < 5
-!
-! 4768 2020-11-02 19:11:23Z suehring
-! Enable 3D data output also with 64-bit precision
+! $Log: data_output_3d.f90,v $
+! Revision 1.3  2006/06/02 15:18:59  raasch
+! +argument "found", -argument grid in call of routine user_data_output_3d
+!
+! Revision 1.2  2006/02/23 10:23:07  raasch
+! Former subroutine plot_3d renamed data_output_3d, pl.. renamed do..,
+! .._anz renamed .._n,
+! output extended to (almost) all quantities, output of user-defined quantities
+!
+! Revision 1.1  2006/02/23 10:21:34  raasch
+! Initial revision
+!
+! Revision 1.13  2005/06/26 20:08:36  raasch
+! +ql_c, ql_v, ql_vp
+!
+! Revision 1.12  2005/05/18 15:47:34  raasch
+! Extensions for NetCDF output
+!
+! Revision 1.11  2003/03/16 09:42:31  raasch
+! Two underscores (_) are placed in front of all define-strings
+!
+! Revision 1.10  2002/06/11 13:13:27  raasch
+! TRIM function added (needed on IBM-systems)
+!
+! Revision 1.9  2002/04/16  08:11:50  08:11:50  raasch (Siegfried Raasch)
+! Output of scalar field s allowed
 ! 
-! 4559 2020-06-11 08:51:48Z raasch
-! file re-formatted to follow the PALM coding standard
-!
-! 4457 2020-03-11 14:20:43Z raasch
-! use statement for exchange horiz added
-!
-! 4444 2020-03-05 15:59:50Z raasch
-! bugfix: cpp-directives for serial mode added
-!
-! 4360 2020-01-07 11:25:50Z suehring
-! Introduction of wall_flags_total_0, which currently sets bits based on static topography
-! information used in wall_flags_static_0
-!
-! 4329 2019-12-10 15:46:36Z motisi
-! Renamed wall_flags_0 to wall_flags_static_0
-!
-! 4182 2019-08-22 15:20:23Z scharf
-! Corrected "Former revisions" section
-!
-! 4162 2019-08-16 05:54:29Z raasch
-! bugfix for r4155
-!
-! 4155 2019-08-14 06:25:18Z raasch
-! bugfix for 3d-output in serial mode (ghost points must not be written)
-!
-! 4127 2019-07-30 14:47:10Z suehring
-! Adjustment for top boundary index for plant-canopy model outputs (merge from branch resler)
-!
-! 4048 2019-06-21 21:00:21Z knoop
-! Moved tcm_data_output_3d to module_interface
-!
-! 4039 2019-06-18 10:32:41Z suehring
-! modularize diagnostic output
-!
-! 3994 2019-05-22 18:08:09Z suehring
-! output of turbulence intensity added
-!
-! 3987 2019-05-22 09:52:13Z kanani
-! Introduce alternative switch for debug output during timestepping
-!
-! 3885 2019-04-11 11:29:34Z kanani
-! Changes related to global restructuring of location messages and introduction of additional debug
-! messages
-!
-! 3814 2019-03-26 08:40:31Z pavelkrc
-! unused variables removed
-!
-! 3655 2019-01-07 16:51:22Z knoop
-! Bugfix: use time_since_reference_point instead of simulated_time (relevant when using wall/soil
-!         spinup)
+! Revision 1.8  2001/03/30 07:44:45  raasch
+! Translation of remaining German identifiers (variables, subroutines, etc.)
+!
+! Revision 1.7  2001/03/09 21:46:23  letzel
+! All comments translated into English.
+!
+! Revision 1.6  2001/01/22 07:40:10  raasch
+! Module test_variables removed
+!
+! Revision 1.5  2000/04/13 14:02:39  schroeter
+! Plotausgabe fuer Gesamtwasser- und Fluessigwassergehalt sowie potentielle
+! Fluessigwassertemperatur
+!
+! Revision 1.4  99/03/02  09:24:51  09:24:51  raasch (Siegfried Raasch)
+! Datenkompression implementiert
+! 
+! Revision 1.3  1998/07/06 12:26:35  raasch
+! + USE test_variables
+!
+! Revision 1.2  1998/03/09 16:24:33  raasch
+! simulated_time_mod verlaengert
 !
 ! Revision 1.1  1997/09/03 06:29:36  raasch
@@ -86,100 +63,32 @@
 ! Description:
 ! ------------
-!> Output of the 3D-arrays in netCDF and/or AVS format.
-!--------------------------------------------------------------------------------------------------!
- SUBROUTINE data_output_3d( av )
-
-
-    USE arrays_3d,                                                                                 &
-        ONLY:  d_exner, e, p, pt, q, ql, ql_c, ql_v, s, tend, u, v, vpt, w
-
+! Output of the 3D-arrays in NetCDF and/or AVS format.
+!------------------------------------------------------------------------------!
+
+    USE array_kind
+    USE arrays_3d
     USE averaging
-
-    USE basic_constants_and_equations_mod,                                                         &
-        ONLY:  lv_d_cp
-
-    USE bulk_cloud_model_mod,                                                                      &
-        ONLY:  bulk_cloud_model
-
-    USE control_parameters,                                                                        &
-        ONLY:  debug_output_timestep, do3d, do3d_no, do3d_time_count, land_surface, message_string,&
-               ntdim_3d, nz_do3d, plant_canopy, psolver, time_since_reference_point, urban_surface,&
-               varnamelength
-
-#if defined( __parallel )
-    USE control_parameters,                                                                        &
-        ONLY:  io_blocks, io_group
-#endif
-
-    USE cpulog,                                                                                    &
-        ONLY: cpu_log, log_point
-
-    USE exchange_horiz_mod,                                                                        &
-        ONLY:  exchange_horiz
-
-    USE indices,                                                                                   &
-        ONLY:  nbgp, nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt, wall_flags_total_0
-
-#if ! defined( __parallel )
-    USE indices,                                                                                   &
-        ONLY:  nx, ny
-#endif
-
-    USE kinds
-
-    USE land_surface_model_mod,                                                                    &
-        ONLY: lsm_data_output_3d, nzb_soil, nzt_soil
-
-    USE module_interface,                                                                          &
-        ONLY:  module_interface_data_output_3d
-
-#if defined( __netcdf )
-    USE NETCDF
-#endif
-
-    USE netcdf_interface,                                                                          &
-        ONLY:  fill_value, id_set_3d, id_var_do3d, id_var_time_3d, nc_stat, netcdf_data_format,    &
-               netcdf_handle_error
-
-    USE particle_attributes,                                                                       &
-        ONLY:  grid_particles, number_of_particles, particles, particle_advection_start, prt_count
-
+    USE cloud_parameters
+    USE control_parameters
+    USE cpulog
+    USE indices
+    USE interfaces
+    USE netcdf_control
+    USE particle_attributes
     USE pegrid
 
-    USE plant_canopy_model_mod,                                                                    &
-        ONLY:  pch_index
-
-    USE radiation_model_mod,                                                                       &
-        ONLY:  nz_urban_b, nz_urban_t
-
-    USE urban_surface_mod,                                                                         &
-        ONLY:  usm_data_output_3d
-
-
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  av        !< flag for (non-)average output
-    INTEGER(iwp) ::  flag_nr   !< number of masking flag
-    INTEGER(iwp) ::  i         !< loop index
-    INTEGER(iwp) ::  ivar      !< variable index
-    INTEGER(iwp) ::  j         !< loop index
-    INTEGER(iwp) ::  k         !< loop index
-    INTEGER(iwp) ::  n         !< loop index
-    INTEGER(iwp) ::  nzb_do    !< vertical lower limit for data output
-    INTEGER(iwp) ::  nzt_do    !< vertical upper limit for data output
-
-    LOGICAL      ::  found     !< true if output variable was found
-    LOGICAL      ::  resorted  !< true if variable is resorted
-
-    REAL(wp)     ::  mean_r    !< mean particle radius
-    REAL(wp)     ::  s_r2      !< sum( particle-radius**2 )
-    REAL(wp)     ::  s_r3      !< sum( particle-radius**3 )
-
-    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  local_pf  !< output array
-
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  to_be_resorted  !< pointer to array which shall be
-                                                            !< output
-
-    CHARACTER (LEN=varnamelength) ::  trimvar  !< TRIM of output-variable string
+    CHARACTER (LEN=9) ::  simulated_time_mod
+
+    INTEGER           ::  av, i, if, j, k, n, pos, prec, psi
+
+    LOGICAL           ::  found, resorted
+
+    REAL              ::  mean_r, s_r3, s_r4
+
+    REAL(spk), DIMENSION(:,:,:), ALLOCATABLE  ::  local_pf
+
+    REAL, DIMENSION(:,:,:), POINTER ::  to_be_resorted
 
 !
@@ -187,50 +96,34 @@
     IF ( do3d_no(av) == 0 )  RETURN
 
-    IF ( debug_output_timestep )  CALL debug_message( 'data_output_3d', 'start' )
-
     CALL cpu_log (log_point(14),'data_output_3d','start')
 
 !
 !-- Open output file.
-!-- For classic or 64bit netCDF output on more than one PE, each PE opens its own file and writes
-!-- the data of its subdomain in binary format. After the run, these files are combined to one
-!-- NetCDF file by combine_plot_fields.
-!-- For netCDF4/HDF5 output, data is written in parallel into one file.
-    IF ( netcdf_data_format < 5 )  THEN
-#if defined( __parallel )
-       CALL check_open( 30 )
+!-- Also creates coordinate and fld-file for AVS.
+!-- In case of a run on more than one PE, each PE opens its own file and
+!-- writes the data of its subdomain in binary format (regardless of the format
+!-- the user has requested). After the run, these files are combined to one
+!-- file by combine_plot_fields in the format requested by the user (netcdf
+!-- and/or avs). 
+    IF ( avs_output  .OR.  ( numprocs > 1 ) )  CALL check_open( 30 )
+
+#if defined( __netcdf )
+    IF ( myid == 0  .AND.  netcdf_output )  CALL check_open( 106+av*10 )
 #endif
-       IF ( myid == 0 )  CALL check_open( 106+av*10 )
-    ELSE
-       CALL check_open( 106+av*10 )
-    ENDIF
-
-!
-!-- For parallel netcdf output the time axis must be limited. Return, if this limit is exceeded.
-!-- This could be the case, if the simulated time exceeds the given end time by the length of the
-!-- given output interval.
-    IF ( netcdf_data_format > 4 )  THEN
-       IF ( do3d_time_count(av) + 1 > ntdim_3d(av) )  THEN
-          WRITE ( message_string, * ) 'Output of 3d data is not given at t=',                      &
-                                      time_since_reference_point, 's because the maximum ',        &
-                                      'number of output time levels is ',                          &
-                                      'exceeded.'
-          CALL message( 'data_output_3d', 'PA0387', 0, 1, 0, 6, 0 )
-          CALL cpu_log( log_point(14), 'data_output_3d', 'stop' )
-          RETURN
-       ENDIF
-    ENDIF
-
-!
-!-- Update the netCDF time axis.
-!-- In case of parallel output, this is only done by PE0 to increase the performance.
+
+!
+!-- Allocate a temporary array with the desired output dimensions.
+    ALLOCATE( local_pf(nxl-1:nxr+1,nys-1:nyn+1,nzb:nz_do3d) )
+
+!
+!-- Update the NetCDF time axis
 #if defined( __netcdf )
     do3d_time_count(av) = do3d_time_count(av) + 1
-    IF ( myid == 0 )  THEN
-       nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_time_3d(av),                                  &
-                               (/ time_since_reference_point /),                                   &
-                               start = (/ do3d_time_count(av) /),                                  &
+    IF ( myid == 0  .AND.  netcdf_output )  THEN
+       nc_stat = NF90_PUT_VAR( id_set_3d(av), id_var_time_3d(av), &
+                               (/ simulated_time /),              &
+                               start = (/ do3d_time_count(av) /), &
                                count = (/ 1 /) )
-       CALL netcdf_handle_error( 'data_output_3d', 376 )
+       IF (nc_stat /= NF90_NOERR)  CALL handle_netcdf_error( 1009 )
     ENDIF
 #endif
@@ -238,39 +131,22 @@
 !
 !-- Loop over all variables to be written.
-    ivar = 1
-
-    DO  WHILE ( do3d(av,ivar)(1:1) /= ' ' )
-
-!
-!--    Initiate found flag and resorting flag
-       found = .FALSE.
+    if = 1
+
+    DO  WHILE ( do3d(av,if)(1:1) /= ' ' )
+!
+!--    Set the precision for data compression.
+       IF ( do3d_compress )  THEN
+          DO  i = 1, 100
+             IF ( plot_3d_precision(i)%variable == do3d(av,if) )  THEN
+                prec = plot_3d_precision(i)%precision
+                EXIT
+             ENDIF
+          ENDDO
+       ENDIF
+
+!
+!--    Store the array chosen on the temporary array.
        resorted = .FALSE.
-       trimvar = TRIM( do3d(av,ivar) )
-
-!
-!--    Temporary solution to account for data output within the new urban surface model
-!--    (urban_surface_mod.f90), see also SELECT CASE ( trimvar ).
-!--    Store the array chosen on the temporary array.
-       nzb_do   = nzb
-!
-!--    Set top index for 3D output. Note in case of plant-canopy model these index is determined by
-!--    pch_index.
-       IF ( plant_canopy  .AND.  trimvar(1:4) == 'pcm_' )  THEN
-          nzt_do   = pch_index
-       ELSE
-          nzt_do   = nz_do3d
-       ENDIF
-
-!
-!--    Allocate a temporary array with the desired output dimensions.
-       ALLOCATE( local_pf(nxl:nxr,nys:nyn,nzb_do:nzt_do) )
-!
-!--    Before each output, set array local_pf to fill value
-       local_pf = REAL( fill_value, KIND=wp )
-!
-!--    Set masking flag for topography for not resorted arrays
-       flag_nr = 0
-
-       SELECT CASE ( trimvar )
+       SELECT CASE ( TRIM( do3d(av,if) ) )
 
           CASE ( 'e' )
@@ -278,32 +154,11 @@
                 to_be_resorted => e
              ELSE
-                IF ( .NOT. ALLOCATED( e_av ) )  THEN
-                   ALLOCATE( e_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   e_av = REAL( fill_value, KIND = wp )
-                ENDIF
                 to_be_resorted => e_av
              ENDIF
 
-          CASE ( 'thetal' )
-             IF ( av == 0 )  THEN
-                to_be_resorted => pt
-             ELSE
-                IF ( .NOT. ALLOCATED( lpt_av ) )  THEN
-                   ALLOCATE( lpt_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   lpt_av = REAL( fill_value, KIND = wp )
-                ENDIF
-                to_be_resorted => lpt_av
-             ENDIF
-
           CASE ( 'p' )
              IF ( av == 0 )  THEN
-                IF ( psolver /= 'sor' )  CALL exchange_horiz( p, nbgp )
                 to_be_resorted => p
              ELSE
-                IF ( .NOT. ALLOCATED( p_av ) )  THEN
-                   ALLOCATE( p_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   p_av = REAL( fill_value, KIND = wp )
-                ENDIF
-                IF ( psolver /= 'sor' )  CALL exchange_horiz( p_av, nbgp )
                 to_be_resorted => p_av
              ENDIF
@@ -311,12 +166,9 @@
           CASE ( 'pc' )  ! particle concentration (requires ghostpoint exchange)
              IF ( av == 0 )  THEN
-                IF ( time_since_reference_point >= particle_advection_start )  THEN
-                   tend = prt_count
-                ELSE
-                   tend = 0.0_wp
-                ENDIF
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      DO  k = nzb_do, nzt_do
+                tend = prt_count
+                CALL exchange_horiz( tend, 0, 0 )
+                DO  i = nxl-1, nxr+1
+                   DO  j = nys-1, nyn+1
+                      DO  k = nzb, nz_do3d
                          local_pf(i,j,k) = tend(k,j,i)
                       ENDDO
@@ -325,43 +177,33 @@
                 resorted = .TRUE.
              ELSE
-                IF ( .NOT. ALLOCATED( pc_av ) )  THEN
-                   ALLOCATE( pc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   pc_av = REAL( fill_value, KIND = wp )
-                ENDIF
+                CALL exchange_horiz( pc_av, 0, 0 )
                 to_be_resorted => pc_av
              ENDIF
 
-          CASE ( 'pr' )  ! mean particle radius (effective radius)
-             IF ( av == 0 )  THEN
-                IF ( time_since_reference_point >= particle_advection_start )  THEN
-                   DO  i = nxl, nxr
-                      DO  j = nys, nyn
-                         DO  k = nzb_do, nzt_do
-                            number_of_particles = prt_count(k,j,i)
-                            IF ( number_of_particles <= 0 )  CYCLE
-                            particles => grid_particles(k,j,i)%particles(1:number_of_particles)
-                            s_r2 = 0.0_wp
-                            s_r3 = 0.0_wp
-                            DO  n = 1, number_of_particles
-                               IF ( particles(n)%particle_mask )  THEN
-                                  s_r2 = s_r2 + particles(n)%radius**2 * particles(n)%weight_factor
-                                  s_r3 = s_r3 + particles(n)%radius**3 * particles(n)%weight_factor
-                               ENDIF
-                            ENDDO
-                            IF ( s_r2 > 0.0_wp )  THEN
-                               mean_r = s_r3 / s_r2
-                            ELSE
-                               mean_r = 0.0_wp
-                            ENDIF
-                            tend(k,j,i) = mean_r
+          CASE ( 'pr' )  ! mean particle radius
+             IF ( av == 0 )  THEN
+                DO  i = nxl, nxr
+                   DO  j = nys, nyn
+                      DO  k = nzb, nzt+1
+                         psi = prt_start_index(k,j,i)
+                         s_r3 = 0.0
+                         s_r4 = 0.0
+                         DO  n = psi, psi+prt_count(k,j,i)-1
+                            s_r3 = s_r3 + particles(n)%radius**3
+                            s_r4 = s_r4 + particles(n)%radius**4
                          ENDDO
+                         IF ( s_r3 /= 0.0 )  THEN
+                            mean_r = s_r4 / s_r3
+                         ELSE
+                            mean_r = 0.0
+                         ENDIF
+                         tend(k,j,i) = mean_r
                       ENDDO
                    ENDDO
-                ELSE
-                   tend = 0.0_wp
-                ENDIF
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      DO  k = nzb_do, nzt_do
+                ENDDO
+                CALL exchange_horiz( tend, 0, 0 )
+                DO  i = nxl-1, nxr+1
+                   DO  j = nys-1, nyn+1
+                      DO  k = nzb, nzt+1
                          local_pf(i,j,k) = tend(k,j,i)
                       ENDDO
@@ -370,20 +212,19 @@
                 resorted = .TRUE.
              ELSE
-                IF ( .NOT. ALLOCATED( pr_av ) )  THEN
-                   ALLOCATE( pr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   pr_av = REAL( fill_value, KIND = wp )
-                ENDIF
+                CALL exchange_horiz( pr_av, 0, 0 )
                 to_be_resorted => pr_av
              ENDIF
 
-          CASE ( 'theta' )
-             IF ( av == 0 )  THEN
-                IF ( .NOT. bulk_cloud_model )  THEN
+          CASE ( 'pt' )
+             IF ( av == 0 )  THEN
+                IF ( .NOT. cloud_physics ) THEN
                    to_be_resorted => pt
                 ELSE
-                   DO  i = nxl, nxr
-                      DO  j = nys, nyn
-                         DO  k = nzb_do, nzt_do
-                            local_pf(i,j,k) = pt(k,j,i) + lv_d_cp * d_exner(k) * ql(k,j,i)
+                   DO  i = nxl-1, nxr+1
+                      DO  j = nys-1, nyn+1
+                         DO  k = nzb, nz_do3d
+                            local_pf(i,j,k) = pt(k,j,i) + l_d_cp *    &
+                                                          pt_d_t(k) * &
+                                                          ql(k,j,i)
                          ENDDO
                       ENDDO
@@ -392,8 +233,4 @@
                 ENDIF
              ELSE
-                IF ( .NOT. ALLOCATED( pt_av ) )  THEN
-                   ALLOCATE( pt_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   pt_av = REAL( fill_value, KIND = wp )
-                ENDIF
                 to_be_resorted => pt_av
              ENDIF
@@ -403,19 +240,11 @@
                 to_be_resorted => q
              ELSE
-                IF ( .NOT. ALLOCATED( q_av ) )  THEN
-                   ALLOCATE( q_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   q_av = REAL( fill_value, KIND = wp )
-                ENDIF
                 to_be_resorted => q_av
              ENDIF
-
+             
           CASE ( 'ql' )
              IF ( av == 0 )  THEN
                 to_be_resorted => ql
              ELSE
-                IF ( .NOT. ALLOCATED( ql_av ) )  THEN
-                   ALLOCATE( ql_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   ql_av = REAL( fill_value, KIND = wp )
-                ENDIF
                 to_be_resorted => ql_av
              ENDIF
@@ -425,8 +254,4 @@
                 to_be_resorted => ql_c
              ELSE
-                IF ( .NOT. ALLOCATED( ql_c_av ) )  THEN
-                   ALLOCATE( ql_c_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   ql_c_av = REAL( fill_value, KIND = wp )
-                ENDIF
                 to_be_resorted => ql_c_av
              ENDIF
@@ -436,8 +261,4 @@
                 to_be_resorted => ql_v
              ELSE
-                IF ( .NOT. ALLOCATED( ql_v_av ) )  THEN
-                   ALLOCATE( ql_v_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   ql_v_av = REAL( fill_value, KIND = wp )
-                ENDIF
                 to_be_resorted => ql_v_av
              ENDIF
@@ -445,36 +266,6 @@
           CASE ( 'ql_vp' )
              IF ( av == 0 )  THEN
-                IF ( time_since_reference_point >= particle_advection_start )  THEN
-                   DO  i = nxl, nxr
-                      DO  j = nys, nyn
-                         DO  k = nzb_do, nzt_do
-                            number_of_particles = prt_count(k,j,i)
-                            IF (number_of_particles <= 0)  CYCLE
-                            particles => grid_particles(k,j,i)%particles(1:number_of_particles)
-                            DO  n = 1, number_of_particles
-                               IF ( particles(n)%particle_mask )  THEN
-                                  tend(k,j,i) =  tend(k,j,i) +                                     &
-                                                 particles(n)%weight_factor / prt_count(k,j,i)
-                               ENDIF
-                            ENDDO
-                         ENDDO
-                      ENDDO
-                   ENDDO
-                ELSE
-                   tend = 0.0_wp
-                ENDIF
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      DO  k = nzb_do, nzt_do
-                         local_pf(i,j,k) = tend(k,j,i)
-                      ENDDO
-                   ENDDO
-                ENDDO
-                resorted = .TRUE.
-             ELSE
-                IF ( .NOT. ALLOCATED( ql_vp_av ) )  THEN
-                   ALLOCATE( ql_vp_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   ql_vp_av = REAL( fill_value, KIND = wp )
-                ENDIF
+                to_be_resorted => ql_vp
+             ELSE
                 to_be_resorted => ql_vp_av
              ENDIF
@@ -482,7 +273,7 @@
           CASE ( 'qv' )
              IF ( av == 0 )  THEN
-                DO  i = nxl, nxr
-                   DO  j = nys, nyn
-                      DO  k = nzb_do, nzt_do
+                DO  i = nxl-1, nxr+1
+                   DO  j = nys-1, nyn+1
+                      DO  k = nzb, nz_do3d
                          local_pf(i,j,k) = q(k,j,i) - ql(k,j,i)
                       ENDDO
@@ -491,8 +282,4 @@
                 resorted = .TRUE.
              ELSE
-                IF ( .NOT. ALLOCATED( qv_av ) )  THEN
-                   ALLOCATE( qv_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   qv_av = REAL( fill_value, KIND = wp )
-                ENDIF
                 to_be_resorted => qv_av
              ENDIF
@@ -500,57 +287,34 @@
           CASE ( 's' )
              IF ( av == 0 )  THEN
-                to_be_resorted => s
-             ELSE
-                IF ( .NOT. ALLOCATED( s_av ) )  THEN
-                   ALLOCATE( s_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   s_av = REAL( fill_value, KIND = wp )
-                ENDIF
-                to_be_resorted => s_av
-             ENDIF
-
+                to_be_resorted => q
+             ELSE
+                to_be_resorted => q_av
+             ENDIF
+             
           CASE ( 'u' )
-             flag_nr = 1
              IF ( av == 0 )  THEN
                 to_be_resorted => u
              ELSE
-                IF ( .NOT. ALLOCATED( u_av ) )  THEN
-                   ALLOCATE( u_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   u_av = REAL( fill_value, KIND = wp )
-                ENDIF
                 to_be_resorted => u_av
              ENDIF
 
           CASE ( 'v' )
-             flag_nr = 2
              IF ( av == 0 )  THEN
                 to_be_resorted => v
              ELSE
-                IF ( .NOT. ALLOCATED( v_av ) )  THEN
-                   ALLOCATE( v_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   v_av = REAL( fill_value, KIND = wp )
-                ENDIF
                 to_be_resorted => v_av
              ENDIF
 
-          CASE ( 'thetav' )
+          CASE ( 'vpt' )
              IF ( av == 0 )  THEN
                 to_be_resorted => vpt
              ELSE
-                IF ( .NOT. ALLOCATED( vpt_av ) )  THEN
-                   ALLOCATE( vpt_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   vpt_av = REAL( fill_value, KIND = wp )
-                ENDIF
                 to_be_resorted => vpt_av
              ENDIF
 
           CASE ( 'w' )
-             flag_nr = 3
              IF ( av == 0 )  THEN
                 to_be_resorted => w
              ELSE
-                IF ( .NOT. ALLOCATED( w_av ) )  THEN
-                   ALLOCATE( w_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   w_av = REAL( fill_value, KIND = wp )
-                ENDIF
                 to_be_resorted => w_av
              ENDIF
@@ -558,68 +322,12 @@
           CASE DEFAULT
 !
-!--          Quantities of other modules
-             IF ( .NOT. found )  THEN
-                CALL module_interface_data_output_3d( av, trimvar, found, local_pf, fill_value,    &
-                                                      resorted, nzb_do, nzt_do                     &
-                                                    )
-             ENDIF
-
-!
-!--          Temporary workaround: ToDo: refactor local_pf allocation
-             IF ( .NOT. found  .AND.  urban_surface  .AND.  trimvar(1:4) == 'usm_' )  THEN
-!
-!--             For urban model quantities, it is required to re-allocate local_pf
-                nzb_do = nz_urban_b
-                nzt_do = nz_urban_t
-
-                DEALLOCATE ( local_pf )
-                ALLOCATE( local_pf(nxl:nxr,nys:nyn,nzb_do:nzt_do) )
-                local_pf = fill_value
-
-                CALL usm_data_output_3d( av, trimvar, found, local_pf, nzb_do, nzt_do )
-                resorted = .TRUE.
-
-!
-!--             If no soil model variable was found, re-allocate local_pf
-                IF ( .NOT. found )  THEN
-                   nzb_do = nzb
-                   nzt_do = nz_do3d
-
-                   DEALLOCATE ( local_pf )
-                   ALLOCATE( local_pf(nxl:nxr,nys:nyn,nzb_do:nzt_do) )
-                ENDIF
-
-             ENDIF
-
-!
-!--          Temporary workaround: ToDo: refactor local_pf allocation
-             IF ( .NOT. found  .AND.  land_surface )  THEN
-!
-!--             For soil model quantities, it is required to re-allocate local_pf
-                nzb_do = nzb_soil
-                nzt_do = nzt_soil
-
-                DEALLOCATE ( local_pf )
-                ALLOCATE( local_pf(nxl:nxr,nys:nyn,nzb_do:nzt_do) )
-                local_pf = fill_value
-
-                CALL lsm_data_output_3d( av, trimvar, found, local_pf )
-                resorted = .TRUE.
-
-!
-!--             If no soil model variable was found, re-allocate local_pf
-                IF ( .NOT. found )  THEN
-                   nzb_do = nzb
-                   nzt_do = nz_do3d
-
-                   DEALLOCATE ( local_pf )
-                   ALLOCATE( local_pf(nxl:nxr,nys:nyn,nzb_do:nzt_do) )
-                ENDIF
-
-             ENDIF
-
-             IF ( .NOT. found )  THEN
-                message_string =  'no output available for: ' // TRIM( do3d(av,ivar) )
-                CALL message( 'data_output_3d', 'PA0182', 0, 0, 0, 6, 0 )
+!--          User defined quantity
+             CALL user_data_output_3d( av, do3d(av,if), found, local_pf, &
+                                       nz_do3d )
+             resorted = .TRUE.
+
+             IF ( myid == 0  .AND.  .NOT. found )  THEN
+                PRINT*, '+++ data_output_3d: no output available for: ', &
+                             do3d(av,if)
              ENDIF
 
@@ -629,10 +337,8 @@
 !--    Resort the array to be output, if not done above
        IF ( .NOT. resorted )  THEN
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO  k = nzb_do, nzt_do
-                   local_pf(i,j,k) = MERGE( to_be_resorted(k,j,i),                                 &
-                                            REAL( fill_value, KIND = wp ),                         &
-                                            BTEST( wall_flags_total_0(k,j,i), flag_nr ) )
+          DO  i = nxl-1, nxr+1
+             DO  j = nys-1, nyn+1
+                DO  k = nzb, nz_do3d
+                   local_pf(i,j,k) = to_be_resorted(k,j,i)
                 ENDDO
              ENDDO
